#include <stdio.h>

/*
  Copyright 2021 Jan 'Manna5' Mleczko

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
*/

int result = 0;
short int working = 1;

int moomin ()
{
  char item[16] = {0};
  int a, b, c;
  scanf ("%s", item);
  if (* item != '.')
    if (* item == '-' && * (item + 1) || * item >= '0' && * item <= '9')
      return atoi (item);
    else
      switch (* item)
      {
        case '#':
          return result;
        case '~':
          return ~ moomin ();
        case '&':
          return moomin () & moomin ();
        case '|':
          return moomin () | moomin ();
        case '^':
          return moomin () ^ moomin ();
        case '+':
          return moomin () + moomin ();
        case '-':
          return moomin () - moomin ();
        case '*':
          return moomin () * moomin ();
        case '/':
          return moomin () / moomin ();
        case '%':
          return moomin () % moomin ();
        case '<':
          return - (moomin () < moomin ());
        case '>':
          return - (moomin () > moomin ());
        case '=':
          return - (moomin () == moomin ());
        case '?':
          a = moomin (); b = moomin (); c = moomin ();
          return a ? b : c;
        case 't':
          return -1;
        case 'f':
          return 0;
        default:
          putchar ('\a');
          break;
      }
  else
    working = 0;
}

int main ()
{
  puts ("Moomin Calculator (C) 2021 Jan 'Manna5' Mleczko");
  while (working)
  {
    putchar ('>');
    result = moomin ();
    printf ("\t%d\n", result);
  }
  return 0;
}
